class GameState
  class WaitingForPlayer < GameState
    
    def on_enter
      input = @game.input_manager.queued_input.shift
      handle_input(input) if input
    end
        
    def handle_input(action)
      case action
      when :pause then $game.pause
      when :restart then $game.restart_level
      when :north, :south, :east, :west
        game.player.move(action) { game.game_state = CheckWorldState.new(EnemyAction) }
      when /throw_(?<dir>\w+)/
        game.player.throw_weapon($~[:dir].to_sym) { game.game_state = CheckWorldState.new(EnemyAction) }
      when :wait
        if game.waiting_allowed?
          game.game_state = CheckWorldState.new(EnemyAction)
        else
          MediaManager.play_sfx("buzzer")
        end
      end
    end
  end
  
  def next_state
    CheckWorldState.new(EnemyAction)
  end
  
  def animation_duration
    100
  end
end
